//***************************************************************************
//
// $Source$
// $Revision$
//
//
//   Latis Networks, Inc. (d/b/a StillSecure)
//     www.stillsecure.com
//     www.stillsecure.org
//
//
//   Copyright (C) 2005-2006 Latis Networks, Inc. (d/b/a StillSecure)
//
//    This file is part of SAPQ.
//
//    SAPQ is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    SAPQ is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAPQ; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
//
//
//     Project: Safe Access Packet Queuing Daemon
//     Module: SAPQ
//     Author: Jim Guggemos
//     Description: Header for main and application-wide classes
//
// $Date$
//
//***************************************************************************

#ifndef __SAPQ_H__
#define __SAPQ_H__

#include "Mutex.h"

void logMessage(const char *format, ...);
void logDebug(const char *format, ...);
bool debugMode();
void setDebugMode(bool mode);
char *errnoString(int errnoValue, char *buf);

class ServiceMonitor
{
public:
    ServiceMonitor();
    
    void setDHCPWatcher(bool running);
    void setSocketServer(bool running);
    void interrupt();

    void blockUntilNotRunning();

    static ServiceMonitor *instance() { return m_instance; }

private:
    ConditionVar m_condx;

    bool m_dhcpWatcherRunning;
    bool m_socketServerRunning;
    bool m_interrupted;

    static ServiceMonitor *m_instance;
};


#endif // __SAPQ_H__
